"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var mobx_react_1 = require("mobx-react");
__export(require("mobx-react"));
var StoreNamesSymbol = '@@StorePropsSymbol';
function getNamespaceValue(store, index) {
    var temp = store;
    for (var _i = 0, _a = index.split('.'); _i < _a.length; _i++) {
        var key = _a[_i];
        temp = temp[key];
        if (temp == undefined) {
            break;
        }
    }
    return temp;
}
function observer(target) {
    var stores = Reflect.getOwnMetadata(target, StoreNamesSymbol);
    if (stores && stores.length) {
        return mobx_react_1.inject(function (store) {
            return stores.reduce(function (result, dataIndex) {
                return (__assign((_a = {}, _a[dataIndex] = getNamespaceValue(store, dataIndex), _a), result));
                var _a;
            }, {});
        })(mobx_react_1.observer(target));
    }
    return target;
}
exports.observer = observer;
function inject(dataIndex) {
    return function (prototype, propertyName) {
        var constructor = prototype.constructor;
        var stores = Reflect.getOwnMetadata(constructor, StoreNamesSymbol);
        if (!dataIndex) {
            dataIndex = propertyName;
        }
        Reflect.defineMetadata(StoreNamesSymbol, stores ? stores.concat(dataIndex) : [dataIndex], constructor);
        Object.defineProperty(prototype, propertyName, {
            enumerable: true,
            configurable: true,
            get: function () {
                return this.props[dataIndex];
            }
        });
    };
}
exports.inject = inject;
